<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('users', function (Blueprint $table) {
            $table->uuid('id')->primary();

            // BASIC
            $table->string('name');
            $table->string('email')->unique();

            $table->timestamp('email_verified_at')->nullable();

            $table->string('password');
            $table->string('status')->default('active');
            $table->string('role')->default('user');

            // SETTINGS
            $table->boolean('reminders_enabled')->default(true);
            $table->boolean('notify_in_app')->default(true);
            $table->boolean('notify_email')->default(false);
            $table->boolean('notify_push')->default(false);
            $table->json('settings')->nullable();
            $table->json('notification_settings')->nullable();

            $table->string('locale')->default('de');
            $table->string('timezone')->default('UTC');
            $table->json('meta')->nullable();


            // SYSTEM
            $table->rememberToken();
            $table->timestamps();

            $table->timestamp('deletion_requested_at')->nullable();
            $table->softDeletes();
        });

        Schema::create('password_reset_tokens', function (Blueprint $table) {
            $table->string('email')->primary();
            $table->string('token');
            $table->timestamp('created_at')->nullable();
        });

        Schema::create('sessions', function (Blueprint $table) {
            $table->string('id')->primary();
            $table->foreignId('user_id')->nullable()->index();
            $table->string('ip_address', 45)->nullable();
            $table->text('user_agent')->nullable();
            $table->longText('payload');
            $table->integer('last_activity')->index();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('users');
        Schema::dropIfExists('password_reset_tokens');
        Schema::dropIfExists('sessions');
    }
};
